package org.eclipse.cdt.rpm.editor;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.cdt.rpm.editor.preferences.PreferenceConstants;


public class RpmPackageProposalsList {
	private ArrayList list = new ArrayList();

	public RpmPackageProposalsList() {
		setPackagesList();
	}

	private void setPackagesList(){
		String rpmpkgsFile = Activator.getDefault().getPreferenceStore().getString(PreferenceConstants.P_RPM_LIST_FILEPATH);
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(rpmpkgsFile)));
			String line = reader.readLine();
			while (line != null) {
				list.add(line.trim());
				line = reader.readLine();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public List getProposals(String prefix) {
		int rpmpkgsMaxProposals = Activator.getDefault().getPreferenceStore().getInt(PreferenceConstants.P_RPM_LIST_MAX_PROPOSALS);
		Iterator iterator = list.iterator();
		List proposalsList = new ArrayList(list.size());
		int i = 0;
		while (iterator.hasNext()) {
			String item[] = new String[2];
			item[0] = (String) iterator.next();
			String message = "Rpm informations are only avalable \nif the proposal list is less than\n\n You can change the item limite in the plugin preferences";
			item[1] = message + rpmpkgsMaxProposals + " item";
			if (item[0].startsWith(prefix)) {
				proposalsList.add(item);
			}
			i++;
		}
		/*
		 * Show RPM informations only if the proposal list is less than 20
		 * TODO: We can add a preference page to give on the user the possibility to modify
		 *       these limit.
		 */
		if (proposalsList.size() < rpmpkgsMaxProposals) {
			iterator = proposalsList.iterator();
			List proposalsListWithInfo = new ArrayList(proposalsList.size());
			while (iterator.hasNext()) {
				String item[] = new String[2];
				item = (String[]) iterator.next();
				item[1] = getRpmInfo(item[0]);
				proposalsListWithInfo.add(item);
			}
			return proposalsListWithInfo;
		} else {
			return proposalsList;
		}
	}

	public String getRpmInfo(String pkgName) {
		String ret = "";
		String[] cmd = new String[] {"rpm","-qi", pkgName};
		try {
			Process child = Runtime.getRuntime().exec(cmd);
			InputStream in = child.getInputStream();
	        int c;
	        while ((c = in.read()) != -1) {
	            ret += ((char)c);
	        }
	        in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return ret;
	}
	

}
