package org.eclipse.cdt.rpm.editor.preferences;

import java.util.ArrayList;
import java.util.StringTokenizer;

import org.eclipse.cdt.rpm.editor.Activator;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.ListEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.preferences.ScopedPreferenceStore;

public class MacroProposalsPreferencePage extends FieldEditorPreferencePage
		implements IWorkbenchPreferencePage {
	ScopedPreferenceStore preferences;

	public MacroProposalsPreferencePage() {
		super(FLAT);
		setPreferenceStore(Activator.getDefault().getPreferenceStore());
	}

	public void init(IWorkbench workbench) {
	}

	protected void createFieldEditors() {
		ListEditor macroListEditor = new MacroListEditor(
				PreferenceConstants.P_MACRO_PROPOSALS_FILESPATH,
				"Macro Proposals paths", getFieldEditorParent());
		addField(macroListEditor);
	}

	class MacroListEditor extends ListEditor {

		public MacroListEditor(String name, String labelText, Composite parent) {
			init(name, labelText);
			createControl(parent);
		}

		protected String createList(String[] items) {
			StringBuffer path = new StringBuffer("");
			for (int i = 0; i < items.length; i++) {
				path.append(items[i]);
				path.append(";");
			}
			return path.toString();
		}

		protected String getNewInputObject() {
			FileDialog dialog = new FileDialog(getShell());
			return dialog.open();
		}

		protected String[] parseString(String stringList) {
			StringTokenizer st = new StringTokenizer(stringList, ";\n\r");
			ArrayList v = new ArrayList();
			while (st.hasMoreElements()) {
				v.add(st.nextElement());
			}
			return (String[]) v.toArray(new String[v.size()]);
		}

	}

}