package org.eclipse.cdt.rpm.editor.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import org.eclipse.cdt.rpm.editor.Activator;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault()
				.getPreferenceStore();
		store.setDefault(PreferenceConstants.P_RPM_LIST_CMD,
				"yum list all | grep - | cut -d \".\" -f 1");
		store.setDefault(PreferenceConstants.P_RPM_LIST_FILEPATH,
		System.getProperty("user.dir") +  "/.pkglist");
		store.setDefault(PreferenceConstants.P_RPM_LIST_MAX_PROPOSALS, "10");
		String defaultMacroPaths = "/usr/lib/rpm/macros;" + System.getProperty("user.home") + "/.rpmmacros";
		store.setDefault(PreferenceConstants.P_MACRO_PROPOSALS_FILESPATH, defaultMacroPaths);
	}

}
